export type Palette = {
    main: string;
    contrastText: string;
    buttonState?: {
        hovered?: string;
        disabled?: string;
        pressed?: string;
        focused?: string;
        disabledText?: string;
    },
    darkMode?: {
        main: string;
        contrastText: string;
        buttonState?: {
            hovered?: string;
            hoveredText?: string;
            pressed?: string;
            pressedText?: string;
            focused?: string;
            disabled?: string;
        }
    }
};

export type Colors = {
    primary: Palette;
    secondary: Palette;
    accentColorA: Palette;
    accentColorB: Palette;
    accentColorC: Palette;
    success: Palette;
    error: Palette;
    warning: Palette;
    info: Palette
}

export type CommonColors = {
    white: string;
    black: string;
}

export type ColorKeys = keyof Colors;
