import "@mui/material/styles";
import "@mui/material/Typography";
import "@mui/material/Button";
import { CSSProperties } from "react";

import { Colors } from "./themes/types";

declare module "@emotion/react" {
  export interface Theme { 
    palette: Colors
  }
}

declare module "@mui/material/styles" {
    interface TypographyVariants {
        h10: CSSProperties;
    }

    interface TypographyVariantsOptions {
        h10?: CSSProperties;
    }

    interface PaletteButtonColor {
        hovered?: string;
        hoveredText?: string;
        pressed?: string;
        pressedText?: string;
        focused?: string;
        focusedText?: string;
        disabled?: string;
        disabledText?: string;
    }

    interface PaletteColor {
      dark?: PaletteOptions;
      light?: PaletteOptions;
      buttonState?: PaletteButtonColor;
      darkMode?: Palette["primary"] & PaletteButtonColor;
    }

    interface Palette {
        accentColorA: PaletteColor;
        accentColorB: PaletteColor;
        accentColorC: PaletteColor;
        success: PaletteColor;
        warning: PaletteColor;
        error: PaletteColor;
        info: PaletteColor;
    }

    interface PaletteOptions {
      accentColorA?: PaletteColor;
      accentColorB?: PaletteColor;
      accentColorC?: PaletteColor;
      success?: PaletteColor;
      warning?: PaletteColor;
      error?: PaletteColor;
      info?: PaletteColor;
    }

}

declare module "@mui/material/styles" {
  interface TypographyVariants {
    h10: CSSProperties;
  }

  // allow configuration using `createTheme`
  interface TypographyVariantsOptions {
    h10?: CSSProperties;
  }
}

declare module "@mui/material/Typography" {
  // Update the Typography's variant prop options
  interface TypographyPropsVariantOverrides {
    h10: true;
    h1: false;
  }
}

declare module "@mui/material/Button" {
  // Update the Button's color prop options
  interface ButtonPropsColorOverrides {
    accentColorA: true;
    accentColorB: true;
    accentColorC: true;
    inherit: false;
  }
}
